<?php
defined( 'ABSPATH' ) || exit;

class NCWM_Display {
    
    public static function displayAjax(){
        if(!isset($_POST['func'])){
            wp_die();
        }
        $action = sanitize_text_field($_POST['func']);
        $function = 'ajax' . ucfirst($action);
        if ($action && method_exists('NCWM_Display', $function)) {
            self::$function();
        }
        return;
    }
    
    public static function ajaxChangecart() {
        if (!isset($_POST['cart_type']) || !$_POST['cart_type']) {
            return;
        }
        $type = 'source';
        $cart_type = sanitize_text_field($_POST['cart_type']);
        if ($cart_type) {
            $defineModel = new NCWM_Define();
            $html = ncwm_get_template(
                            'forms/' . $defineModel->getCartGroup($cart_type) . '.php',
                            array(
                                'type'      => $type,
                                'fields'    => $defineModel->getFormFields($cart_type),
                                'cart_type' => $cart_type,
                                'guide'     => $defineModel->getCartInstruction($cart_type)
                            )
            );
            $response = array(
                'html' => $html
            );
        } else {
            $response = array(
                'html' => false
            );
        }
        self::responseJson($response);
    }
    
    public static function ajaxMigration() {
        $app_url = NCWM_Main::APP_URL . '?store=' . get_site_url();
        $args = array(
            'body' => $_POST,
            'timeout' => '3000',
            'redirection' => '5',
            'httpversion' => '1.0',
            'blocking' => true,
            'headers' => array(),
            'cookies' => array()
        );
        $response = wp_remote_post($app_url, $args);
        if (!is_wp_error( $response ) && self::isJson($response['body'])) {
            die($response['body']);
        } else {
            if (is_wp_error( $response )) {
                $response = array(
                    'result' => 'error',
                    'error'   => 'A problem occurred while sending request to migration server!'
                );
            } else {
                $response = array(
                    'result' => 'error',
                    'error'   => 'A problem occurred while sending request to migration server! Error: ' . $response['body']
                );
            }
            self::responseJson($response);
        }
    }
    
    public static function ajaxSetup() {
        self::ajaxMigration();
    }
    
    public static function ajaxConfig() {
        self::ajaxMigration();
    }
    
    public static function ajaxClear() {
        self::ajaxMigration();
    }
    
    public static function ajaxMigrate() {
        self::ajaxMigration();
    }
    
    public static function ajaxReindex() {
        self::ajaxMigration();
    }
    
    public static function loadMigrationPage() {
        ncwm_display_template('index.php');
    }
    
    public static function loadHowItWorks() {
        ncwm_display_template('how-it-works.php');
    }
    
    public static function loadExtraServices() {
        ncwm_display_template('extra-services.php');
    }
    
    public static function loadOfficialMigration() {
        ncwm_display_template('pro-license.php');
    }
    
    public static function responseJson($response) {
        die(json_encode($response));
    }
    
    public static function isJson($string) {
        json_decode($string);
        return (json_last_error() == JSON_ERROR_NONE);
    }

}
